package arbol.binariodebusqueda.cliente;

import arbol.binariodebusqueda.modelo.*;
import arbol.graficar.BTreePrinter;

/**
 * Crea un árbol binario de busqueda, hace los recorridos
 * e imprime por consola el árbol.
 * @author libardo
 *
 */
public class ClienteMain {

	public static void main(String[] args) {
		ArbolBinarioOrdenado arbol = new ArbolBinarioOrdenado();
		try {
			arbol.insertar(new Entero(10));
			arbol.insertar(new Entero(15));
			arbol.insertar(new Entero(30));
			arbol.insertar(new Entero(5));
			arbol.insertar(new Entero(2));
			arbol.insertar(new Entero(1));
		} catch (Exception e) {
			System.out.println("Error: " + e.getMessage());
		}
		System.out.println("Preorden:");
		arbol.preorden();
		System.out.println("\nInorden:");
		arbol.inorden();
		System.out.println("\nPostorden:");
		arbol.postorden();

		Nodo aux = arbol.buscar(new Entero(700));
		if (aux == null)
			System.out.println("\nDato no encontrado");
		else
			System.out.println("\nEncontrado el dato:" + aux.getValor());
		BTreePrinter.printNode(arbol.getRaiz());
		System.out.println("Padre del 30:"+ arbol.buscarPadre(new Entero(30)).getValor());
	}

}
