package arbol.graficar;


/**
 * Representa un nodo a ser dibujado, acompañado de los puntos (X,Y) del nodo
 * y de su nodo padre
 * @author libardo
 *
 */
public class Vertice {
	/**
	 * Dato a ser graficado, es el valor de cada nodo
	 */
	private String dato;
	/**
	 * Punto X,Y del nodo 
	 */
	private Punto puntoNodo;
	/**
	 * Punto X,Y del nodo padre
	 */
	private Punto puntoPadre;
	/**
	 * Constructor
	 * @param dato dato
	 * @param puntoNodo punto nodo
	 * @param puntoPadre punto del nodo padre
	 */
	public Vertice(String dato, Punto puntoNodo, Punto puntoPadre) {
		super();
		this.dato = dato;
		this.puntoNodo = puntoNodo;
		this.puntoPadre = puntoPadre;
	}
	
	public String getDato() {
		return dato;
	}

	public void setDato(String dato) {
		this.dato = dato;
	}

	public Punto getPuntoNodo() {
		return puntoNodo;
	}

	public void setPuntoNodo(Punto puntoNodo) {
		this.puntoNodo = puntoNodo;
	}

	public Punto getPuntoPadre() {
		return puntoPadre;
	}

	public void setPuntoPadre(Punto puntoPadre) {
		this.puntoPadre = puntoPadre;
	}

}
