package arboln.modelo;

import utilidades.Lista;
import utilidades.PosicionIlegalException;

public class ArbolN {
	private NodoArbolN raiz;

	public ArbolN() {
		raiz = null;
	}

	public NodoArbolN getRaiz() {
		return raiz;
	}

	public void setRaiz(NodoArbolN raiz) {
		this.raiz = raiz;
	}

	public void agregarNodo(NodoArbolN padre, NodoArbolN nuevo) {

		padre.agregarHijo(nuevo);
	}

	public boolean vacioArbolN() {
		return raiz == null;
	}

	/*
	 * public boolean estaArbolN(NodoArbolN aux, T elem) { Lista lst; if
	 * (vacioArbolN(a)) return false; else if (raiz == elem) return true; else {
	 * lst = aux.getHijos(); for (primLista(lst); !finLista(lst);
	 * elimLista(lst)) if (estaArbolN(infoLista(lst), elem)) {
	 * destruirLista(lst); return true; } return false; } }
	 */
	public void inordenArbolN() throws PosicionIlegalException {
		inordenArbolN(raiz);
	}

	public void inordenArbolN(NodoArbolN aux) throws PosicionIlegalException {
		if (aux != null) {
			Lista<NodoArbolN> lst = aux.getHijos();
			// Si no tiene hijos
			if (lst.getTamanio() == 0)
				visitar(aux);
			else {
				// Si tiene hijos
				inordenArbolN(lst.getValor(0));// IZQUIERDO
				visitar(aux);// RAIZ
				for (int i = 1; i < lst.getTamanio(); i++)
					// DERECHO
					inordenArbolN(lst.getValor(i));
			}
		}
	}

	public void preordenArbolN() throws PosicionIlegalException {
		preordenArbolN(raiz);
	}

	public void preordenArbolN(NodoArbolN aux) throws PosicionIlegalException {
		if (aux != null) {
			Lista<NodoArbolN> lst = aux.getHijos();
			if (lst.getTamanio() == 0)
				visitar(aux);
			else {
				visitar(aux);// raiz

				preordenArbolN(lst.getValor(0)); // izquierdo

				for (int i = 1; i < lst.getTamanio(); i++)
					// derecho
					preordenArbolN(lst.getValor(i));
			}
		}
	}

	public void postordenArbolN() throws PosicionIlegalException {
		postordenArbolN(raiz);
	}

	public void postordenArbolN(NodoArbolN aux) throws PosicionIlegalException {
		if (aux != null) {
			Lista<NodoArbolN> lst = aux.getHijos();
			if (lst.getTamanio() == 0)
				visitar(aux);
			else {
				postordenArbolN(lst.getValor(0)); // izquierdo
				for (int i = 1; i < lst.getTamanio(); i++)
					// derecho
					postordenArbolN(lst.getValor(i));
				visitar(aux);// raiz
			}
		}
	}

	public NodoArbolN buscarNodoArbolN(Object buscado)
			throws PosicionIlegalException {
		Comparable dato = (Comparable) buscado;
		return localizar(raiz, dato);

	}

	public NodoArbolN localizar(NodoArbolN aux, Comparable valor)
			throws PosicionIlegalException {

		// inorden
		if (vacioArbolN())
			return null;
		else {
			Lista<NodoArbolN> lst = aux.getHijos();

			if (lst.getTamanio() == 0) {
				// Visitar:
				if (comparar(aux, valor))
					return aux;
			} else {
				// IZQUIERDO
				NodoArbolN dato = localizar(lst.getValor(0), valor);

				if (dato != null)// Para que termine la recursividad cuando lo
									// encuentre
					return dato;
				// RAIZ:
				if (comparar(aux, valor))
					return aux;
				// DERECHO
				for (int i = 1; i < lst.getTamanio(); i++) {
					dato = localizar(lst.getValor(i), valor);
					if (dato != null) // Para que termine la recursividad cuando
										// lo encuentre
						return dato;
				}
			}
		}
		return null;

	}

	public boolean comparar(NodoArbolN n1, Comparable buscado) {
		return (n1.getValor().esIgual(buscado));
	}

	public void visitar(NodoArbolN aux) {
		System.out.print(aux.getValor().toString() + " ");
	}

}
