package arboln.modelo;

import utilidades.Lista;

;
public class NodoArbolN {
	private Comparable valor;
	private Lista<NodoArbolN> hijos;

	public NodoArbolN() {
		hijos = new Lista<NodoArbolN>();
	}

	public NodoArbolN(Comparable valor) {
		this.valor = valor;
		hijos = new Lista<NodoArbolN>();
	}

	public int getNumberoDeHijos() {

		return hijos.getTamanio();

	}

	public boolean tieneHijos() {

		return (getNumberoDeHijos() > 0);
	}

	public void agregarHijo(NodoArbolN hijo) {
		hijos.agregar(hijo);
	}

	public Comparable getValor() {
		return valor;
	}

	public void setValor(Comparable valor) {
		this.valor = valor;
	}

	public Lista<NodoArbolN> getHijos() {
		return hijos;
	}

	public void setHijos(Lista<NodoArbolN> hijos) {
		this.hijos = hijos;
	}

	public String toString() {
		return "" + valor;
	}
	/**
	 * 
	 */
	public void print() {
		print("", true);
	}
	/**
	 * Fuente: 
	 * http://stackoverflow.com/questions/4965335/how-to-print-binary-tree-diagram
	 * @param prefix
	 * @param isTail
	 */
	private void print(String prefix, boolean isTail) {
		System.out.println(prefix + (isTail ? "└── " : "├── ") + valor);
		try{
			
		
		if (hijos != null) {
			for (int i = 0; i < hijos.getTamanio() - 1; i++) {
				hijos.getValor(i).print(prefix + (isTail ? "    " : "│   "),
						false);
			}
			if (hijos.getTamanio() >= 1) {
				hijos.getValor(hijos.getTamanio() - 1).print(
						prefix + (isTail ? "    " : "│   "), true);
			}
		}
		}
		catch(Exception e){
			System.out.println(e.getMessage());
		}
	}

}
